
#ifndef __DISPATCHER_H__
#define __DISPATCHER_H__

#include <avr/io.h>
#include <stdio.h>
#include <stdarg.h>
#include <inttypes.h>
#include <avr/pgmspace.h>
/* 
 * author: Marcell GAL
 * If the defines hee are messed up (relative to dispatcher_arr[])
 * disaster will happen.
 */

#define IGNACT		(0)
#define IGNDEACT	(IGNACT+1)
#define PRIMARY_TRIGGER_REENABLE	(IGNDEACT+1)
#define SECONDARY_TRIGGER_REENABLE	(PRIMARY_TRIGGER_REENABLE+1)
#define STIM_LOW	(SECONDARY_TRIGGER_REENABLE+1)
#define STIM_HIGH	(STIM_LOW+1)
#define EVENT_BENCHMARK	(STIM_HIGH+1)
#define EDIS_STOP_SAW	(EVENT_BENCHMARK+1)

#ifdef GENBOARDv3

#define INJ_START       (EDIS_STOP_SAW+1)
#define INJ_PWM         (INJ_START+1)
#define INJ_STOP        (INJ_PWM+1)
#define INJ_ALL         (INJ_STOP+1)
#define KNOCK_START     (INJ_ALL+1)
#define KNOCK_STOP      (KNOCK_START+1)
#define EVENT_BOOSTACT	(KNOCK_STOP+1)
#else // not GENBOARDv3

#define INJASTOP	(EDIS_STOP_SAW+1)
#define INJBSTOP	(INJASTOP+1)
#define INJAGOPWM	(INJBSTOP+1)
#define INJBGOPWM	(INJAGOPWM+1)

#endif	// not GENBOARDv3

// defines used by the INJ_ALL event
#define INJ_ALL_START   (0)
#define INJ_ALL_PWM     (INJ_ALL_START+1)
#define INJ_ALL_STOP    (INJ_ALL_PWM+1)


// 4 is faster than 5, but only tolerate events 0..15 so take care
#define VAL_T_SPLIT	(4)
#define v_shiftup(upv) (upv<<VAL_T_SPLIT)
#define v_shiftdown(v) (v>>VAL_T_SPLIT)
#define v_trim(v) (v & 0x0f)

// static __inline__ void dispatcher (val_t v);
extern PGM_VOID_P dispatcher_arr[] PROGMEM;

#endif
