
#ifndef EGO_H
#define EGO_H

#include <avr/sfr_defs.h>
#include "adc.h"

// seconds for ego to warmup
#define EGO_WARMUP 60
#define EGO_COOL   2

// config.ego_conf defines:
#define PID_EGO_CONTROL 0				// only if my_make has NBO2_PID_EGO_EXPERIMENT
// #define WBO2_SENSOR 1				// see config13
// #define INCREDIBLE_EGO_CONTROL 2 	// always used for WBO2
// #define EGO_NBO2_TARGET 4 killed, dangerous with corr.lambda used unconditionally
#define NBO2_ON_ADC7 5

static inline uint8_t ego_voltage(void)
{
#ifdef GENBOARDv3
	if (config.ego_conf & _BV(NBO2_ON_ADC7))
		return sensors8(EGO_2);
	else
#endif
		return sensors8(EGO_1);
}

// it is wired in fuelcalc, ego, comm, even in storage
#define EGOCORR_BASE 128

void init_ego(void);
void ego_nbo2_ready(void);
void o2(void);
uint16_t calc_target_afr(void);

#define HIST_LENGTH 4

extern uint8_t ego_history[HIST_LENGTH];
extern uint16_t ego_corr_filt;
extern uint16_t target_afr;


#endif
