/*
  Logging mechanisms...
  makes it possible to peak in the entire memory
*/
   /*!
   * \addtogroup g_debug Debug Routines
   */
/*@{*/

#include "log.h"
#include "global.h"
#include "adc.h"

#include <avr/io.h>
#include <inttypes.h>
#include <avr/pgmspace.h>
#include <stdio.h>



/*
Menu TODO:

cmd start logging
cmd stop logging
cmd to fill array, starting from address 0 (how do we start/stop?)

Comm TODO:
send hex chars


Misc. thoughts:
What happens if user null-terminates the array while we are sending (at a lower position)?

*/




/*
  Elements which can be logged.
  format: [pointer][length]
*/
PROGMEM struct log_element_t log_elements[] = {
	{(uint8_t *)NULL, 0}, // DONT REMOVE!!!
	{(uint8_t *)sensor_filt, 16},
	{(uint8_t *)&engine.status, sizeof(struct engine_t)},
	{(uint8_t *)&rtc.sec, 2}

};


// this array contains indices to the log_elements.
uint8_t log_vars[MAX_LOG_ELEMENTS];

// point at last element in log_vars[]
// set my menu command
uint8_t log_last_idx;

/*@}*/

