/* Copyright 2005 (C) by Michael Richards. All rights reserved.  */
/* $Id: sipr.h,v 1.5.2.3 2005/05/27 05:43:14 hackish Exp $ */

#ifndef __SIPR_H__
#define __SIPR_H__

#include "inttypes.h"
#ifndef EMULATOR
//#include "avr/sipr.h"
#else
#include "emulator/sipr.h"
#endif

/* SIPR constants */
#define SIPR_HEADER 0x0A

/* the maximum size of an incoming packet defined */
#define MAX_INC_SIZE 4

/* SIPR packet types */
#define SIPR_PAK_NAK		0x00
#define SIPR_PAK_ACK 		0x01
#define SIPR_PAK_GET_VERSION 	0x02
#define SIPR_PAK_SET_BAUD 	0x03
#define SIPR_PAK_GET_TABLESIZE 	0x04
#define SIPR_PAK_GET_TABLEDATA 	0x05
#define SIPR_PAK_SET_TABLEDATA 	0x06
#define SIPR_PAK_READ_SENSORS 	0x07

// structure to hold an incoming packet
struct sipr_t {
  uint8_t seq;   // packet sequence number
  uint8_t type;  // packet type ID
  uint8_t size;  // number of bytes expected in the packet
  uint8_t data[MAX_INC_SIZE];
  uint16_t CRC;  // the CRC value for this packet
  uint16_t recCRC;  // the CRC value that the sender claims
  uint8_t idx;   // the number of bytes processed so far
};

extern void sipr_init(void);
extern void sipr_timeout(void);
extern void sipr_process_inc(uint8_t c);
extern struct sipr_t sipr_incoming;
extern struct sipr_t sipr_outgoing;
extern uint8_t sipr_inc_timeout;
extern uint8_t sipr_packet_NAK(uint8_t i);
extern uint8_t sipr_packet_ACK(uint8_t i);
#endif /* __SIPR_H__ */
